"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const net_1 = __importDefault(require("net"));
const index_1 = require("../index");
const timeout = 2000;
class ConsoleClient {
    isconnected = false;
    port = index_1.PORT;
    socket;
    constructor() { }
    untilrun() {
        this.connect().then(isSuccess => {
            this.isconnected = isSuccess;
            if (isSuccess) {
                if (this.socket) {
                    this.socket.on('data', data => {
                        console.log(data.toString());
                    });
                }
            }
            else {
                setTimeout(() => {
                    this.untilrun();
                }, timeout);
            }
        });
    }
    connect(port = this.port) {
        return new Promise((resolve, reject) => {
            try {
                const client = net_1.default.createConnection({
                    port,
                }, () => {
                    console.log('connected!');
                    this.socket = client;
                    resolve(true);
                });
                client
                    .on('data', data => {
                    console.log(data.toString());
                })
                    .on('end', () => {
                    console.log('connection closed!');
                })
                    .on('error', (err) => {
                    if (err.code === 'ECONNREFUSED') {
                        console.log('fail');
                        resolve(false);
                    }
                });
            }
            catch (err) {
                reject(err);
            }
        });
    }
}
exports.default = ConsoleClient;
